ARCHIVE_KEEPNDAYS=30
BACKUP_RUNEVERYNTHDAY=1
-function upperme {
- echo $(basename $0) | tr '[:lower:]' '[:upper:]'
+_ERROR_ENCOUNTERED=0
+_UPPERME=$(echo $(basename $0) | tr '[:lower:]' '[:upper:]')
+
+function timestamp {
+ echo $(date +"[%y-%m-%d %H:%M:%S]")
+}
+
+function scottyline {
+ echo $(timestamp) $_UPPERME: $@
}
function scottyinfo {
- echo $(upperme): $@
+ if ($_ERROR_ENCOUNTERED -eq 0); then
+ scottyline $@
+ else
+ scottyline $@ >&2
+ fi
}
function scottyerror {
- echo $(upperme): $@ >&2
+ scottyline $@ >&2
+ _ERROR_ENCOUNTERED=1
}
-if [ $(pidof -x $(basename $0) | wc -w) -gt 2 ]; then
- scottyerror Another instance of $(basename $0) is already running!
- exit 1
-fi
+function ssh255 {
+ ssh $@
+ sshret=$?
-while getopts "qn:" opt; do
- case $opt in
- q)
- exec > /dev/null
- ;;
- n)
- BACKUP_RUNEVERYNTHDAY=$OPTARG
- ;;
- esac
-done
+ if [ $sshret -eq 255 ]; then
+ scottyerror "SSH connection failed!"
+ exit 1
+ else
+ return $sshret
+ fi
+}
function grepbackups {
- ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+ ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
}
function isIncomplete {
- if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+ if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
return 0
else
return 1
fi
}
-function isIncompleteOrNthDay {
- if isIncomplete || \
- [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
+function isNthDay {
+ if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
then
return 0
else
fi
}
+function latestTooOld {
+ for oldbackup in $(grepbackups); do
+ tstamp=$(echo $oldbackup | cut -d'-' -f1)
+
+ if [ $(( $(date +%s) - $tstamp )) -lt \
+ $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
+ then
+ return 1
+ fi
+ done
+
+ return 0
+}
+
function scottysync {
timestamp=$(date +%s)
- scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
+ scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
if [ ! -d "$SYNC_SRC" ]; then
- scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
+ scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
return 1
fi
if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
- scottyerror Source dir $SYNC_SRC is empty. Not syncing!
+ scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
return 1
fi
rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
fi
- if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
- scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
- ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
+ if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+ scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
+ ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
fi
if isIncomplete; then
- scottyerror Continuing old incomplete backup
+ scottyerror "Continuing old incomplete backup."
fi
- scottyinfo Starting rsync
+ scottyinfo "Starting rsync."
rsync -e ssh \
-v -aHAX --numeric-ids --delete --delete-excluded \
--link-dest=$dir_current \
$SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
if [ $? -eq 0 ]; then
- scottyinfo Timestamping completed backup and linking to current backup
- ssh $REMOTE_HOST \
+ scottyinfo "Timestamping completed backup and linking to current backup."
+ ssh255 $REMOTE_HOST \
"mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
+ else
+ scottyerror "Rsync failed."
fi
while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
- scottyinfo Removing old backup $oldestbackup
- ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+ scottyinfo "Removing old backup $oldestbackup."
+ ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
else
break
fi
done
}
-function prepare {
- scottyinfo "Preparing for sync"
+function deleteLock {
+ if ! rmdir /var/lock/$(basename $0); then
+ scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
+ fi
}
-function cleanup_abrt {
- scottyinfo "No cleanup_abrt function was defined."
-}
+function cleanup_abort {
+ scottyerror "Caught exit signal! Cleaning up."
+
+ cleanup ABORT
-function _cleanup_abrt {
- scottyerror "Caught exit signal! Cleaning up..."
- cleanup_abrt
if [ $(jobs -p) ]; then
- scottyerror TERMinating remaining child processes...
+ scottyerror "TERMinating remaining child processes."
kill $(jobs -p)
fi
+
+ deleteLock
+
exit
}
-function prepare {
- scottyinfo "No prepare function was defined."
+function cleanup {
+ scottyinfo "No cleanup function was defined."
}
-function _prepare {
- prepare
+function prepare {
+ scottyinfo "No prepare function was defined."
}
function cleanup_normal {
- scottyinfo "No cleanup_normal function was defined."
+ cleanup
+ deleteLock
}
-function _cleanup_normal {
- cleanup_normal
+function printhelp {
+ cat <<EOF
+Usage: $(basename $0) [OPTION]...
+
+Recognized options:
+ -q Only output errors
+ -n Run only on nth day
+ -h Print out this help
+EOF
}
function backmeupscotty {
- if ! isIncompleteOrNthDay; then
- scottyinfo "This is not the nth day and no incomplete backup exists."
+ while getopts "qn:h" opt; do
+ case $opt in
+ q)
+ exec > /dev/null
+ ;;
+ n)
+ BACKUP_RUNEVERYNTHDAY=$OPTARG
+ ;;
+ h)
+ printhelp
+ exit 0
+ ;;
+ esac
+ done
+
+ ssh255 $REMOTE_HOST exit
+
+ if latestTooOld; then
+ scottyerror "The latest backup is too old."
+ elif isNthDay; then
+ scottyinfo "This is the nth day."
+ else
+ scottyinfo "No backup has to be done. Exiting."
exit 0
fi
- trap _cleanup_abrt EXIT
+ scottyinfo "Performing backup."
- _prepare
+ trap cleanup_abort EXIT
+
+ prepare
scottysync
- _cleanup_normal
- trap - EXIT
+ trap cleanup_normal EXIT
+
+ exit 0
}
+
+if ! mkdir /var/lock/$(basename $0); then
+ scottyerror "Another instance of $(basename $0) is still running!"
+ exit 1
+else
+ trap deleteLock EXIT
+fi